/*---------------------------------------------------------------------------*
  Project:  NintendoWare
  File:     eft_ParticleDeclaration.vsh
  
  Copyright (C)2011-2012 Nintendo All rights reserved.
  
  These coded instructions, statements, and computer programs contain proprietary
  information of Nintendo and/or its licensed developers and are protected by
  national and international copyright laws. They may not be disclosed to third
  parties or copied or duplicated in any form, in whole or in part, without the
  prior written consent of Nintendo.
  
  The content herein is highly confidential and should be handled accordingly.
 *---------------------------------------------------------------------------*/


//------------------------------------------------------------------------------
// JX^}CYVF[_`

// USR_SETTING_1 ` 8               JX^VF[_[U[ZbeBO
// USR_SETTING_NONE                 JX^VF[_𗘗pȂ
// USR_VERTEX_SETTING_1             JX^VF[_[U[ZbeBO/p~\
// USR_VERTEX_SETTING_NONE          JX^VF[_𗘗pȂ

// TARGET_CAFE                      WiiURpC
// TARGET_WINDOWS                   WindowsRpC

// MESH_TYPE_PRIMITIVE              ͂v~eBu

// USR_FLAG_0 ` 31                 JX^VF[_tO(`FbN{bNX)
// USR_SWITCH_FLAG_0 ` 31          JX^VF[_XCb`(WI{^)
// USR_VERTEX_FLAG_0 ` 31          JX^VF[_tO(`FbN{bNX)
// USR_VERTEX_SWITCH_FLAG_0 ` 31   JX^VF[_XCb`(WI{^)




//------------------------------------------------------------------------------
// JX^}CY\\bh

//------------------------------------------------------------------------------
// [U[Ǝ̒_̍ŏIꍇɏ㏑܂B
// #define USE_USR_FINAL_ADJUSTMENT_VERTEX_PROCSS
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// [U[Ǝ̐EW͂𒲐ꍇɏ㏑܂B
// #define USE_USR_ADJUSTMENT_WORLD_POSITION
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// @̎擾
// [U[@̎擾𒲐ꍇɏ㏑܂B
// #define USE_USR_GET_LOCAL_NORMAL
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// [JWn̐ڐxNg擾
// [U[[JWn̐ڐxNg𒲐ꍇɏ㏑܂B
// #define USE_USR_GET_LOCAL_TANGENT
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// [JWn̏]@xNg擾
// [U[[JWn̏]@xNg𒲐ꍇɏ㏑܂B
// #define USE_USR_GET_LOCAL_BINORMAL
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// v~eBũXP[Z擾\bh
// [U[v~eBuXP[Zl𒲐ꍇɏ㏑܂B
// #define USE_USR_GET_PRIMITIVE_SCALE_Z
//------------------------------------------------------------------------------





//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
#define VERTEX_TRANSFORM_MODE_BILLBOARD             (0)	    // r{[h
#define VERTEX_TRANSFORM_MODE_PLATE_XY              (1)	    // XYʃp[eBN
#define VERTEX_TRANSFORM_MODE_PLATE_XZ              (2)	    // XZʃp[eBN
#define VERTEX_TRANSFORM_MODE_DIRECTIONAL_Y         (3)	    // fBNViYr{[h
#define VERTEX_TRANSFORM_MODE_DIRECTIONAL_POLYGON   (4)	    // fBNVi|S
#define VERTEX_TRANSFORM_MODE_Y_BILLBOARD           (8)	    // Yr{[h


// ]@\𗘗p邩ǂB
#define VERTEX_ROTATION_MODE_NO_USE                 (0)	    // ]sȂ
#define VERTEX_ROTATION_MODE_USE                    (1)	    // ]s

// eNX`Wn
#ifdef TARGET_WINDOWS
#define TEXCOORD_ADJUSTMENT                         (0.5)	
#endif
#ifdef TARGET_CAFE
#define TEXCOORD_ADJUSTMENT                         (-0.5)	
#endif


//------------------------------------------------------------------------------
// jtH[ ubN
//------------------------------------------------------------------------------
uniform viewUniformBlock
{
    mat4    viewMat;						                // view        }gNX
    mat4    vpMat;						                    // view * proj }gNX
    mat4    bldMat;						                    // r{[h}gNX
    vec4    eyeVec;						                    // xNg
    vec4    eyePos;						                    // ʒu
    vec4    depthBufferTexMat;						        // fvXobt@eNX`p}gNX
    vec4    frameBufferTexMat;						        // t[obt@eNX`p}gNX
    vec4    viewParam;                                      // near / far / / /
};

uniform emitterStaticUniformBlock
{
    vec4    uvScaleInit;                                    // eNX`XP[l
    vec4    rotBasis;                                       // ]ʒu( x / y / / / )
    vec4    u_shaderParam;                                  // VF[_p[^
};

uniform emitterDynamicUniformBlock
{
    vec4    emitterColor0;                                   // G~b^J[0
    vec4    emitterColor1;                                   // G~b^J[1
};



//------------------------------------------------------------------------------
// Agr[g
//------------------------------------------------------------------------------
in vec4     v_inPos;                                        // ͒_ ( -0.5, 0.5 ) -> ( 0.5, -0.5 )
in uint     v_inIndex;                      	            // ̓CfbNX ( 0, 1, 2, 3 )

in vec4     v_inTexCoord;                   	            // ̓eNX`W@v~eBupɓ͂
in vec3     v_inNormal;                                     // ͖@@@@@@@v~eBupɓ͂
in vec4     v_inColor;                                      // ̓J[@@@@@v~eBupɓ͂

in vec4     v_inScl;                        	            // 傫ƒS(p[eBNP)
in vec4     v_inTexAnim;                    	            // eNX`WAj(p[eBNP)
in vec4     v_inSubTexAnim;                    	            // eNX`WAj(p[eBNP)
in vec4     v_inTexRotateAnim;                              // eNX`W]Aj(p[eBNP)
in vec4     v_inWldPos;                     	            // \ʒu(p[eBNP)
in vec4     v_inWldPosDf;                   	            // Ot[Ƃ̍(p[eBNP)
in vec4     v_inColor0;                     	            // J[0(p[eBNP)
in vec4     v_inColor1;                     	            // J[1(p[eBNP)
in vec4     v_inRot;                        	            // ]l(p[eBNP)
in vec4     v_inEmtMat0;                     	            // G~b^}gNX(p[eBNP)
in vec4     v_inEmtMat1;                     	            // G~b^}gNX(p[eBNP)
in vec4     v_inEmtMat2;                     	            // G~b^}gNX(p[eBNP)


#define ptclScaleX          v_inScl.x                       // p[eBNXP[ X
#define ptclScaleY          v_inScl.y                       // p[eBNXP[ Y
#define cameraOffset        v_inWldPos.w                    // JItZbg


#define uvInitScaleX        uvScaleInit.x                   // eNX`WXP[X
#define uvInitScaleY        uvScaleInit.y                   // eNX`WXP[Y
#define uvScaleX            v_inTexAnim.z                   // eNX`WXP[X
#define uvScaleY            v_inTexAnim.w                   // eNX`WXP[Y
#define uvRotate            v_inScl.z                       // eNX`0W ]l
#define uvTransX            v_inTexAnim.x                   // eNX`WX
#define uvTransY            v_inTexAnim.y                   // eNX`WY


#define uvSubInitScaleX     uvScaleInit.z                   // TueNX`WXP[X
#define uvSubInitScaleY     uvScaleInit.w                   // TueNX`WXP[Y
#define uvSubScaleX         v_inSubTexAnim.z                // TueNX`WXP[X
#define uvSubScaleY         v_inSubTexAnim.w                // TueNX`WXP[Y
#define uvSubRotate         v_inScl.w                       // eNX`1W ]l
#define uvSubTransX         v_inSubTexAnim.x                // TueNX`WX
#define uvSubTransY         v_inSubTexAnim.y                // TueNX`WY


//------------------------------------------------------------------------------
// @֘A
//------------------------------------------------------------------------------
vec3        g_worldNormal;	                         	    // @
vec3        g_worldTangent;                         	    // ڐ
vec3        g_worldBinormal;                         	    // ]@
vec3		g_worldVertexPos;				                // _[hW


//------------------------------------------------------------------------------
// tOgVF[_ɓnl
//------------------------------------------------------------------------------
out vec4    v_outColor0;                                    // o̓J[0
out vec4    v_outColor1;					                // o̓J[1
out vec2    v_outTexCoord;					                // o̓eNX`W
out vec2    v_outMultiTexCoord;				                // o̓}`eNX`W
out vec4    v_outPos;					                    // fvXl擾p
out vec4    v_outDepthTexCoordProj;				            // eNX`fvXl擾p
out vec4    v_outFrameTexCoordProj;				            // eNX`t[l擾p
out vec4    v_outPrimitiveColor;				            // v~eBuJ[


