//------------------------------------------------------------------------------
/**	@file	UsrShader.fsh
 *	@brief	gsys{JX^_VF[_
 *	@author Yuichiro Okamura
 */
//-------------------------

/***********************************************************************************************

		w͈͓[vp[eBN

************************************************************************************************/
#ifdef USR_VERTEX_SETTING_1

// w͈̓[vp[eBNVF[_[uniform
uniform AreaLoopShaderVtxUniform
{
    vec4        g_vec0;
    vec4        g_vec1;
    vec4        g_vec2;
    vec4        g_vec3;
    vec4        g_vec4;
};

//---------------------------------------------------
// [U[Ǝ̐EW𒲐
//---------------------------------------------------
#define USE_USR_ADJUSTMENT_WORLD_POSITION

#define BOX_POS					g_vec0.xyz	// ̒Sʒu
#define BOX_SCALE				g_vec1.xyz	// ̑傫
#define BOX_SCALE_INV			g_vec2.xyz	// ̑傫̋t
#define REPEAT_OFS				g_vec3.xyz	// s[gɈړItZbg
#define BOX_ALPHA_RATIO			g_vec4.xyz	// ̒[Ń𔖂銄


//========================================================
//
//		FragmentShader ɓnϐ
//
//========================================================
float g_mulAlpha;							// ŌɃAt@lɏZl

// [hW␳
void AdjustmentWorldPosition()
{
	g_mulAlpha=1;							// ŌɃAt@lɏZl
	vec3 tgtPos, boxPos, basePos;
	
	//--------------------------------------------------
	// wTCY̔Ɏ߂鏈
	//--------------------------------------------------
	// ̒S߂
	tgtPos = BOX_POS;
	
	// p[eBN̒S_WnɈړāÄʒuoĂ
	// ip[eBN̒S_gpĂ̂́AS_ׂĂ𓯂_œ߁j
	vec3 ofs = REPEAT_OFS*0.1;
	basePos = (v_inWldPos.xyz+ofs) - tgtPos.xyz;
	boxPos = basePos;
	
	// -0.5`+0.5ɃXP[O
	boxPos *= BOX_SCALE_INV;
	
	// 0`1ɂ킹āÂ݂oĖ߂
	boxPos += vec3(0.5,0.5,0.5);
	boxPos = fract(boxPos);
	vec3 alphaPos = boxPos;			// ̒[̃ľvZp(0.0f`1.0f)ɐKlۑ
	boxPos -= vec3(0.5,0.5,0.5);
	
	// ̃XP[ɖ߂
	boxPos *= BOX_SCALE;
	
	// ̈ʒuƂ̍oāA_ʒuɑ
	gl_Position.xyz += (boxPos - basePos) + ofs;
	
	//--------------------------------------------------
	// ̒[̃𔖂鏈
	//--------------------------------------------------
	vec3 mulA0 = clamp( alphaPos.xyz / BOX_ALPHA_RATIO, 0, 1);					// 0.0f  ` wl ̃l
	vec3 mulA1 = clamp( (vec3(1,1,1)-alphaPos.xyz) / BOX_ALPHA_RATIO, 0, 1);	// wl` 1.0f   ̃l
	vec3 mulA = mulA0 * mulA1;
	// lɔf
	g_mulAlpha *= mulA.x * mulA.y * mulA.z;
}

#define USE_USR_FINAL_ADJUSTMENT_VERTEX_PROCSS
void FinalAdjustmentVertexProcess()
{
	// vZZlKp
	v_outColor0.a *= g_mulAlpha;
}
#endif



